-- Load Settings
TalentSwitch_Builds =  {
						{
						}, 
						{
						}, 
						{
						}, 
						{
						}, 
					};
TalentSwitch_Settings = {};

CreateFrame("Button","TalentSwitch",UIParent,"SecureHandlerClickTemplate,SecureHandlerStateTemplate"):RegisterEvent("ADDON_LOADED");
TalentSwitch:SetScript("OnEvent",function(self)
	self:UnregisterEvent("ADDON_LOADED");

	TalentSwitch.makeButtons()

	for i=1,7 do
		for j=1,3 do
			_G['PlayerTalentFrameTalentsTalentRow'..i..'Talent'..j]:SetScript("OnClick", function() TalentSwitch.ChangeTalent(i,j,false,nil); end);
		end
	end

	-- before doing a spec switch, change talent names to a TalentSwitch string, so they can be resolved to the new spec's talents.
	local specButton = PlayerTalentFrameSpecializationLearnButton:GetScript("OnClick")
	PlayerTalentFrameSpecializationLearnButton:SetScript("OnClick", function(self) TalentSwitch.doMacros(1) specButton(self) end)
end);

local frame = CreateFrame("Button","TalentSwitch2",UIParent,"SecureHandlerClickTemplate,SecureHandlerStateTemplate");
local menuFrame = CreateFrame("Frame", "TSwitchMenuFrame", UIParent, "UIDropDownMenuTemplate")
tinsert(UISpecialFrames, menuFrame:GetName())

local frameMacros = CreateFrame("Frame")
frameMacros:SetScript("OnEvent", function() TalentSwitch.doMacros(0) end) --fix unused talents into used ones
frameMacros:RegisterEvent("UPDATE_MACROS")
local frameMacros2 = CreateFrame("Frame")
frameMacros2:SetScript("OnEvent",  function() TalentSwitch.doMacros(2) end) --fix TalentSwitch talent labels to real talents
frameMacros2:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

local frameCancel = CreateFrame("Frame")

local timeTotal=0;
local inFlight=0;
local predictedDests = {};

--Talent switching overrides
function TalentSwitch.ChangeTalent(row, col, bulkLoad, bName)
	
	if InCombatLockdown() then
		UIErrorsFrame:AddMessage("You are in combat",1,0,0);
		return;
	end

	local spellID, name, iconTexture, selected, available=GetTalentInfo(row,col,1);
	local localizedClass, englishClass, classIndex = UnitClass("player");


	if timeTotal > 1.5 and UnitLevel("player") ~= 110 then
		return;
	end
		
		if not selected and not bulkLoad and LearnTalents(spellID) then
		--successfully changed talent
			timeTotal=0;					  --reset the cleaning delay so it happens after the most recent talent change
			frame:RegisterEvent("PLAYER_TALENT_UPDATE");
			frame:SetScript("OnEvent", function (self) TalentSwitch.getReadyToClean(self, row) end);
	
			if classIndex == 11 then TalentSwitch.barTidy() end --you need to pre-empt this as a druid, or shapeshifting breaks things
	
		elseif not selected and bulkLoad and spellID and LearnTalents(spellID) then
			timeTotal=0;
			frame:RegisterEvent("PLAYER_TALENT_UPDATE");
			frame:SetScript("OnEvent", function (self) TalentSwitch.getReadyToClean(self, row); TalentSwitch.LoadBuild(bName, row) end);
	
			if classIndex == 11 and UnitLevel("player") ~= 110 then TalentSwitch.barTidy() end
	
		elseif bulkLoad then
			TalentSwitch.LoadBuild(bName, row)
		end

end

function TalentSwitch.getReadyToClean(self, row)
	self:UnregisterEvent("PLAYER_TALENT_UPDATE");
	self:SetScript("OnEvent", nil);

	--Swap over old talents for new ones on your action bars
	if TalentSwitch.doBars(row) and UnitLevel("player") ~= 110 then
		if classIndex~=11 then			--non-druids haven't done this yet, druids have because of shape-shifting screwing stuff up.
			TalentSwitch.barTidy()
		end

		self:SetScript("OnUpdate", function (self, elapsed) timeTotal=timeTotal+elapsed; if timeTotal >2 then TalentSwitch.talentUpdate(self) end end);
		local localizedClass, englishClass, classIndex = UnitClass("player");

	elseif classIndex == 11 and UnitLevel("player") ~= 110 then
		predictedDests = {} --druids that didnt change a bar talent (they changed a passive etc.) need to clean this up.
	end

	TalentSwitch.doMacros(0)
end

function TalentSwitch.barTidy()
	inFlight = inFlight+1; --the default UI will throw another talent in flight onto your bar
	local predNumber=0;    --you have not found any blank spots yet
	for i = 1, 24 do
		local j=i
		if i>12 then
			j=j+48;
		end
		local type, id, subtype = GetActionInfo(j);
		if id == nil then
			predNumber=predNumber +1;  --found a blank action button
			if predNumber == inFlight then  --find the 1st if only 1 button is in flight, find the 2nd if 2 are, etc.
				table.insert(predictedDests,j);  --add button to list of places to be cleaned up
				break;
			end
		end
	end
end

function TalentSwitch.talentUpdate(self)
	self:SetScript("OnUpdate", nil);
	timeTotal = 0

	--Clear default actionbar placement
	TalentSwitch.clearPlaceholder()

end


function TalentSwitch.doBars(row)

	local passive=false;

	local talents = {}
	for i = 1, 7 do
		talents[i] = {}
	end
	local active = {}
	local activeName = {}

	for i = 1,3 do
		local talentID, name, iconTexture, selected, available, spellID= GetTalentInfo(row,i,1)

		if name and talentID then
			if selected then
				active[row] = spellID
				activeName[row] = name
			else
				table.insert(talents[row], name)
			end
		end
	end
	
	for i = 1, 120 do					 --loop through all the buttons on all the actionbars. 12 buttons, 10 bars.
		local type, id, subtype = GetActionInfo(i)
		local name = GetSpellInfo(id)

		if type ~= "macro" and type ~= nil then

			if active[row] ~= nil and id ~= nil then

				passive = IsPassiveSpell(active[row]) or TalentSwitch.TreatAsPassive(activeName[row])
				if passive == false and (name == talents[row][1] or name == talents[row][2]) then

					PickupAction(i)
					ClearCursor()
					PickupSpell(active[row])
					PlaceAction(i)

					print("Replaced "..name.." with "..tostring(activeName[row]).." on button "..i..".")
				end
			end
		end
	end

	ClearCursor()
	return not passive
end

function TalentSwitch.doMacros(forSpecChange)


	local talents = {}
	local active = {}	

	for i = 1, 7 do
		talents[i] = {}
	end


	for i = 1, 7 do
	for i2 = 1,3 do
		local spellID, name, iconTexture, selected, available = GetTalentInfo(i,i2,1)

		if i ~= nil and i <= 7 and i >= 0 then
			table.insert(talents[i], name)
		else
			print(GetTalentInfo(i,i2,1))
		end

		if selected then
			active[i] = name
		end
	end
	end


	local general, character = GetNumMacros()
	character = character + 120
	
	for j = 1, general do
		TalentSwitch.sub(j, talents, active, forSpecChange)
	end

	for j = 121,  character do
		TalentSwitch.sub(j, talents, active, forSpecChange)
	end

end

function TalentSwitch.sub(j, talents, active, forSpecChange)

	local tiers = 7
	local name, tex, body, flag = GetMacroInfo(j)

	if body ~= nil then
		local bbody = body --so we only update macros if theres an actual change we need a backup to compare to

		for i = 1, tiers do
			if active[i] ~= nil and forSpecChange==0 then
				local in_str = TalentSwitch.esc(active[i])
			
				for k = 1, 3 do
					if talents[i][k] ~= active[i] then
		
						local out_str = TalentSwitch.esc(talents[i][k])
	
--						body=TalentSwitch.rev_custom(active[i], talents[i][k], body, 0) -- reverse custom mappings (NYI)
						body=body:gsub(out_str, in_str) -- switch talent names to the new talent	
					end
				end


--				body=TalentSwitch.do_custom(active[i], body) -- and activate the new talent's mappings (NYI)

			elseif active[i] ~= nil and forSpecChange==1 then  --save talents as labels to preserve accross spec changes
				local in_str = TalentSwitch.esc(active[i])
				body=body:gsub(in_str, "TSwitch"..i.."_")

				frameCancel:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED") --just in case you dont actually change spec afterall
				frameCancel:SetScript("OnEvent", function() TalentSwitch.sub(j, talents, active,2) end)

			elseif active[i] ~= nil and forSpecChange==2 then  -- turn labels back to talents
				local in_str = TalentSwitch.esc(active[i])
				body=body:gsub("TSwitch"..i.."_", in_str)

				frameCancel:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
				frameCancel:SetScript("OnEvent", nil);
			end
		end

		if bbody ~= body then --only if the macro has actually changed
			if string.len(body) < 256 then
				EditMacro(j, nil, nil, body)
			else
				print("TalentSwitch - ERROR: could not update macro "..name.." due to length constraints. ("..string.len(body).."/255)")
			end
		end
	end
end

function TalentSwitch.TreatAsPassive(name)

--Talents that replace a baseline ability are basically passive that buff that ability.
--We don't want to put these on the bar, default UI will handle that by replacing the baseline ability.

	local blackList = 	{
					["Hungering Rune Weapon"]=true, ["Clawing Shadows"]=true, ["Dark Arbiter"]=true, ["Defile"]=true, 				--DK
					["Demon Blades"]=true, ["Netherwalk"]=true, ["Desperate Instincts"]=true, 							--DH
					["Incarnation: Chosen of Elune"]=true, ["Incarnation: King of the Jungle"]=true, ["Brutal Slash"]=true, 			--Druid
					["Dire Frenzy"]=true, ["Sidewinders"]=true, ["Steel Trap"]=true, ["Caltrops"]=true, ["Ranger's Net"]=true, ["Butchery"]=true, 	--Hunter
					["Shimmer"]=true, ["Lonely Winter"]=true, 											--mage
					["Chi Torpedo"]=true, ["Serenity"]=true,											--monk
					["Beacon of Virtue"]=true, ["Blessed Hammer"]=true, ["Blessing of Spellwarding"]=true, ["Hand of the Protector"]=true, 		--paladin
					["Zeal"]=true, ["Blade of Wrath"]=true, ["Divine Hammer"]=true, ["Crusade"]=true,						--paladins...
					["Mindbender"]=true, ["Purge the Wicked"]=true, ["Mind Bomb"]=true, ["Mind Spike"]=true, 					--priest
					["Parley"]=true, ["Slice and Dice"]=true, ["Gloomblade"]=true, 									--rogue
					["Storm Elemental"]=true, ["Boulderfist"]=true, ["Voodoo Totem"]=true, 								--shaman
					["Drain Soul"]=true, ["Demonbolt"]=true, 											--warlock
					["Impending Victory"]=true,													--warrior
				}

	if GetSpecialization() == 1 then																--warrior
		blackList["Ravager"]=true
	else
		blackList["Ravager"]=nil
	end

	if blackList[name] == true then
		return true;
	end

	return false;
end

function TalentSwitch.clearPlaceholder()

	for i,v in pairs(predictedDests) do	-- go throught the list of buttons to clear
		if v~=nil and v~=0 then
			PickupAction(v);
			ClearCursor();
		end
	end

	inFlight=0				-- everythings landed now
	predictedDests={};			-- clear list of buttons that talents land on
end

--talent saving
function TalentSwitch.makeButtons()
	TalentSwitch.Load = CreateFrame("Button", "", PlayerTalentFrame, "OptionsButtonTemplate")
	TalentSwitch.Load:SetPoint("BOTTOMRIGHT", PlayerTalentFrame, "BOTTOMRIGHT", -4,4)
	TalentSwitch.Load:SetText("Load")
	TalentSwitch.Load:SetScript("OnClick", TalentSwitch.makeLoadMenu)

	TalentSwitch.Save = CreateFrame("Button", "", PlayerTalentFrame, "OptionsButtonTemplate")
	TalentSwitch.Save:SetPoint("BOTTOMRIGHT", PlayerTalentFrame, "BOTTOMRIGHT", -98,4)
	TalentSwitch.Save:SetText("Save")
	TalentSwitch.Save:SetScript("OnClick", TalentSwitch.makeSaveMenu)
end

function TalentSwitch.makeLoadMenu()
	local count = GetNumEquipmentSets();
	local menu = {	{ text="Load Build:", notCheckable=true, isTitle=true} }
	
	for key,value in pairs(TalentSwitch_Builds[GetSpecialization()]) do

		local chck = (TalentSwitch_Builds[GetSpecialization()][key][8]=="") --no gear set options
		local sets = {{text="none", notCheckable=false, isNotRadio=false, checked=chck, func=function() TalentSwitch_Builds[GetSpecialization()][key][8]=""; TalentSwitch.makeLoadMenu(); end}}

		--gear set picker
		for i=1,count do
			chck = (TalentSwitch_Builds[GetSpecialization()][key][8]==GetEquipmentSetInfo(i))
			table.insert(sets, {text=GetEquipmentSetInfo(i), notCheckable=false, isNotRadio=false, checked=chck, func=function() TalentSwitch_Builds[GetSpecialization()][key][8]=GetEquipmentSetInfo(i); TalentSwitch.makeLoadMenu(); end} );
		end

		local menurow = {text=key, notCheckable=true, hasArrow=true, func=function() TalentSwitch.LoadBuild(key,0) end, menuList=sets};
		table.insert(menu, menurow)
	end
	table.insert(menu, { text="Close", notCheckable=true})

	menuFrame:SetPoint("TOPLEFT", TalentSwitch.Load, "BOTTOMLEFT")
	EasyMenu(menu, menuFrame, menuFrame, 0 , 35, "MENU");
end

function TalentSwitch.makeSaveMenu()
	local menu = {	{ text="Save Build As:", notCheckable=true, isTitle=true},
			{ text="New Build", notCheckable=true, func=TalentSwitch.SaveAsNew}
			}

	for key,value in pairs(TalentSwitch_Builds[GetSpecialization()]) do
		local menurow = {text=key, notCheckable=true, hasArrow=true, menuList={
									{text="Replace", func=function() TalentSwitch.menuSaveAsClick(key) end},
									{text="Delete", func=function() TalentSwitch.menuDeleteClick(key) end}
								} }
		table.insert(menu, menurow)
	end
	table.insert(menu, { text="Close", notCheckable=true})
	
	menuFrame:SetPoint("TOPLEFT", TalentSwitch.Save, "BOTTOMLEFT")
	EasyMenu(menu, menuFrame, menuFrame, 0 , 35, "MENU");
end

function TalentSwitch.menuSaveAsClick(name)
	StaticPopupDialogs["TALENTSWITCH_DELETE"].OnAccept=function() TalentSwitch.SaveAsName(name) end;
	StaticPopup_Show ("TALENTSWITCH_DELETE", "replace", name);
end

function TalentSwitch.menuDeleteClick(name)
	StaticPopupDialogs["TALENTSWITCH_DELETE"].OnAccept=function() TalentSwitch.Delete(name) end;
	StaticPopup_Show ("TALENTSWITCH_DELETE", "delete", name);
end

function TalentSwitch.SaveAsNew()
	StaticPopup_Show ("TALENTSWITCH_SAVE")
end

function TalentSwitch.SaveAsName(name)

	local talentList = {}

	for i=1,7 do
		for j=1,3 do
			local tID, name, tex, selected, avail, sID, n, row, col = GetTalentInfo(i,j,1);
			if selected then
				talentList[i]=j
			end
		end
	end

	TalentSwitch_Builds[GetSpecialization()][name] = talentList;
	TalentSwitch_Builds[GetSpecialization()][name][8] = "";
end

function TalentSwitch.LoadBuild(name, index)

	if InCombatLockdown() then
		return;
	end

	if index==7 then
		print("Loaded talent build: "..name)

		--load gear set
		if TalentSwitch_Builds[GetSpecialization()][name][8]~=nil and TalentSwitch_Builds[GetSpecialization()][name][8]~="" then
			local success = UseEquipmentSet(TalentSwitch_Builds[GetSpecialization()][name][8]);
			if success then
				print ("TalentSwitch: Equipped gear set "..TalentSwitch_Builds[GetSpecialization()][name][8]..".");
			else
				print ("TalentSwitch: Could not load the appropriate gear set. You may have deleted or renamed the chosen gear set ("..TalentSwitch_Builds[GetSpecialization()][name][8]..").")
			end
		end

		return
	end

	local i=index+1
	local v= TalentSwitch_Builds[GetSpecialization()][name][i]
	TalentSwitch.ChangeTalent(i,v,true, name)
end

function TalentSwitch.Delete(name)
	TalentSwitch_Builds[GetSpecialization()][name] = nil
end

StaticPopupDialogs["TALENTSWITCH_DELETE"] = {
  text = "Are you sure you want to %s %s?",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

StaticPopupDialogs["TALENTSWITCH_SAVE"] = {
  text = "Enter a name for this saved set:",
  button1 = "Save",
  button2 = "Cancel",
  OnAccept = function(self)
      text = self.editBox:GetText()
      TalentSwitch.SaveAsName(text)
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
  hasEditBox=true,
  enterClicksFirstButton = 1,
}


--Utility functions
function TalentSwitch.esc(x)
  return (x:gsub('%%', '%%%%')
           :gsub('%^', '%%%^')
           :gsub('%$', '%%%$')
           :gsub('%(', '%%%(')
           :gsub('%)', '%%%)')
           :gsub('%.', '%%%.')
           :gsub('%[', '%%%[')
           :gsub('%]', '%%%]')
           :gsub('%*', '%%%*')
           :gsub('%+', '%%%+')
           :gsub('%-', '%%%-')
           :gsub('%?', '%%%?'))
end
